Loading...
Searching...
No Matches
Ogre::Resource Class Referenceabstract
Core » Resources

Abstract class representing a loadable resource. More...

`#include <OgreResource.h>`

Inheritance diagram for Ogre::Resource:
[legend]

## Classes

class | Listener

## Public Types

enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions

| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.

## Additional Inherited Members

Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Detailed Description

Abstract class representing a loadable resource.

See also
  Resource Management

Subclasses must implement:

1. A constructor, overriding the same parameters as the constructor defined by this class. Subclasses are not allowed to define constructors with other parameters; other settings must be settable through accessor methods before loading.
2. The loadImpl() and unloadImpl() methods - mSize must be set after loadImpl()
3. StringInterface ParamCommand and ParamDictionary setups in order to allow setting of core parameters (prior to load) through a generic interface.

## Member Enumeration Documentation

## LoadingState

enum Ogre::Resource::LoadingState

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## LoadingFlags

enum Ogre::Resource::LoadingFlags

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Useful to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## Constructor & Destructor Documentation

## Resource()

Ogre::Resource::Resource | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Standard constructor.

Parameters

  creator | Pointer to the ResourceManager that is creating this resource
  name | The unique name of the resource
  handle | Handle to the resource
  group | The name of the resource group to which this resource belongs
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualResourceLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualResourceLoader instance is strongly recommended.

## ~Resource()

virtual Ogre::Resource::~Resource | ( |  | ) |

virtual

Virtual destructor.

Shouldn't need to be overloaded, as the resource deallocation code should reside in unload()

See also
  Resource::unload()

## Member Function Documentation

## prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = false | ) |

virtual

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = false | ) |

virtual

Loads the resource, if it is not already.

If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Referenced by Ogre::BspLevel::BspSceneManager.

## reload()

virtual void Ogre::Resource::reload | ( | LoadingFlags | flags = LF_DEFAULT | ) |

virtual

Reloads the resource, if it is already loaded.

Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::Mesh.

References LF_DEFAULT.

## isReloadable()

bool Ogre::Resource::isReloadable | ( | void |  | ) | const

inline

Returns true if the Resource is reloadable, false otherwise.

## isManuallyLoaded()

bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const

inline

Is this resource manually loaded?

## unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |

virtual

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

## getSize()

size_t Ogre::Resource::getSize | ( | void |  | ) | const

inline

Retrieves info about the size of the resource.

## touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |

virtual

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::CgProgram, and Ogre::Material.

Referenced by Ogre::Material::touch().

## getName()

const String & Ogre::Resource::getName | ( | void |  | ) | const

inline

Gets resource name.

Referenced by Ogre::RTShader::ShaderGenerator::getRenderState(), Ogre::RTShader::ShaderGenerator::hasShaderBasedTechnique(), Ogre::RTShader::ShaderGenerator::invalidateMaterial(), Ogre::RTShader::ShaderGenerator::removeAllShaderBasedTechniques(), OgreBites::TrayManager::resourceLoadStarted(), and Ogre::RTShader::ShaderGenerator::validateMaterial().

## getHandle()

ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const

inline

## isPrepared()

bool Ogre::Resource::isPrepared | ( | void |  | ) | const

inline

Returns true if the Resource has been prepared, false otherwise.

References LOADSTATE_PREPARED.

## isLoaded()

bool Ogre::Resource::isLoaded | ( | void |  | ) | const

inline

Returns true if the Resource has been loaded, false otherwise.

References LOADSTATE_LOADED.

## isLoading()

bool Ogre::Resource::isLoading | ( |  | ) | const

inline

Returns whether the resource is currently in the process of background loading.

References LOADSTATE_LOADING.

## getLoadingState()

LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const

inline

Returns the current loading state.

## isBackgroundLoaded()

bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const

inline

Returns whether this Resource has been earmarked for background loading.

This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

## setBackgroundLoaded()

void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |

inline

Tells the resource whether it is background loaded or not.

See also
  Resource::isBackgroundLoaded. Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

## escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |

virtual

Escalates the loading of a background loaded resource.

If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

## addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |

virtual

Register a listener on this resource.

See also
  Resource::Listener

## removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |

virtual

Remove a listener on this resource.

See also
  Resource::Listener

## getGroup()

const String & Ogre::Resource::getGroup | ( | void |  | ) | const

inline

Gets the group which this resource is a member of.

Referenced by Ogre::RTShader::ShaderGenerator::getRenderState(), Ogre::RTShader::ShaderGenerator::hasShaderBasedTechnique(), Ogre::RTShader::ShaderGenerator::invalidateMaterial(), Ogre::RTShader::ShaderGenerator::removeAllShaderBasedTechniques(), and Ogre::RTShader::ShaderGenerator::validateMaterial().

## changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |

virtual

Change the resource group ownership of a Resource.

This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## getCreator()

ResourceManager * Ogre::Resource::getCreator | ( | void |  | ) |

inline

Gets the manager which created this resource.

## getOrigin()

const String & Ogre::Resource::getOrigin | ( | void |  | ) | const

inline

Get the origin of this resource, e.g.

a script file name.

This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## _notifyOrigin()

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |

inline

Notify this resource of it's origin.

## getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const

inline virtual

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |

virtual

Manually mark the state of this resource as having been changed.

You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## _fireLoadingComplete()

void Ogre::Resource::_fireLoadingComplete | ( | bool | unused = false | ) |

Firing of loading complete event.

You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## _firePreparingComplete()

void Ogre::Resource::_firePreparingComplete | ( | bool | unused = false | ) |

Firing of preparing complete event.

You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## _fireUnloadingComplete()

void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |

Firing of unloading complete event.

You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

The documentation for this class was generated from the following file:

- OgreResource.h